
package ics.uci.edu.Calico.Readers;


import ics.uci.edu.Calico.models.Snapshot;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Color;
import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.util.PPaintContext;
import java.awt.Rectangle;


public class LoggerImage extends PNode{
	
	public static Color ADD_SCRAP_COLOR = Color.GREEN;
	public static Color ADD_RELATIONSHIP_COLOR = new Color(0, 200, 0);
	public static Color DRAW_COLOR = Color.BLACK;
	public static Color SELECT_SCRAP_COLOR = Color.CYAN;
	public static Color DELETE_SCRAP_COLOR = Color.RED;
	public static Color MODIFY_SCRAP_COLOR = Color.BLUE;
	public static Color MODIFY_RELATIONSHIP_COLOR = Color.BLUE;
	public static Color SAVE_COLOR = Color.YELLOW;
	public static Color LOAD_COLOR = Color.ORANGE;
	public static Color GO_DOWN_COLOR = Color.LIGHT_GRAY;
	public static Color GO_UP_COLOR = Color.DARK_GRAY;
	public static Color MOVE_SCRAP_COLOR = Color.BLUE;
	
	private Snapshot snapshot;
	private Image image;
	private Rectangle rect;
	
	public LoggerImage(Snapshot s, Image i, Rectangle r){
		snapshot = s;
		image = i;
		rect = r;
	}	

	public boolean setBounds() {
		if (super.setBounds(rect))
			return true;
		return false;
	}
	
	public void paint(PPaintContext aPaintContext) {
		Graphics2D g2 = aPaintContext.getGraphics(); 
		g2.setPaint(getPaint());
		
		g2.setColor(Color.WHITE);
		g2.fillRect(rect.x, rect.y, rect.width, rect.height);
		g2.drawImage(image, rect.x, rect.y, null);
		g2.setColor(getBorderColor());
		g2.drawRect(rect.x-1, rect.y-1,rect.width+1, rect.height+1);
	}
	
	private Color getBorderColor(){
		int type = snapshot.getType();
		
		if(type == Snapshot.ADD_SCRAP){
			return ADD_SCRAP_COLOR;}
		if(type == Snapshot.ADD_RELATIONSHIP){
			return ADD_RELATIONSHIP_COLOR;}
		if(type == Snapshot.DRAW){
			return DRAW_COLOR;}
		if(type == Snapshot.SELECT_SCRAP){
			return SELECT_SCRAP_COLOR;}
		if(type == Snapshot.DELETE_SCRAP){
			return DELETE_SCRAP_COLOR;}
		if(type == Snapshot.MODIFY_SCRAP){
			return MODIFY_SCRAP_COLOR;}
		if(type == Snapshot.MODIFY_RELATIONSHIP){
			return MODIFY_RELATIONSHIP_COLOR;}
		if(type == Snapshot.SAVE){
			return SAVE_COLOR;}
		if(type == Snapshot.LOAD){
			return LOAD_COLOR;}
		if(type == Snapshot.GO_DOWN){
			return GO_DOWN_COLOR;}
		if(type == Snapshot.GO_UP){
			return GO_UP_COLOR;}
		if(type == Snapshot.MOVE_SCRAP){
			return MOVE_SCRAP_COLOR;}
	
		return Color.BLACK;
	}
	

	public void translate(double dX, double dY) {
		rect.translate(new Double(dX).intValue(), new Double(dY).intValue());
		setBounds();
	}
	
	public void setLocation(double dX, double dY) {
		rect.setLocation(new Double(dX).intValue(), new Double(dY).intValue());
		setBounds();
	}
	
	/*
	Resizing requires a new image to be generated from the snapshotPainter,
	and I dont think I want the VBImage to know about the snapshot it came
	from, so that is not possible right now. A new, resized, VBImage would
	need to be created.

	This class may be expanded later on, for example if I want to manually
	draw icons, annotations or borders on the image based on one or more
	of the snapshots qualities, it will be possible to add that here.
	*/
}		
	
	
	
	
	
	
	