package ics.uci.edu.Calico.UI;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.RenderingHints;
import java.awt.Stroke;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.util.PPaintContext;

import ics.uci.edu.Calico.Structures.BGElementController;
import ics.uci.edu.Calico.Structures.PLine;
import ics.uci.edu.Calico.models.BGElementModel;

public class BGElementPainter extends PNode {

	BGElementModel model;
	Stroke stroke;

	private static final long serialVersionUID = 1L;
	
	public BGElementPainter() {
		model = new BGElementModel(new Polygon(), Color.black, -1);
		stroke = new BasicStroke(1.0f);
	}
	
	public BGElementPainter(BGElementModel m) {
		model = BGElementController.copy(m);
		stroke = new BasicStroke(1.0f);
	}
	
	
	public void clear() {
		model.poly.reset();
	}
	
	
	public void removePoints(int a, int b) {
		Polygon n = new Polygon();
		for (int i = 0; i < model.poly.npoints; i++) {
			if (i < a || i > b)
				n.addPoint(model.poly.xpoints[i], model.poly.ypoints[i]);
		}
		model.poly = n;
	}
	
	
	public void addPoint(int x, int y) {
		model.poly.addPoint(x, y);
		setBounds(model.poly.getBounds2D());
	}
	
	
	public Polygon getPoly() {
		return model.poly;
	}
	
	/*
	public Polygon getPoly() {
		Polygon ret = new Polygon();
		for (int i = 0; i < this.getPointCount(); i++) {
			ret.addPoint(new Double(getLineReference().getX(i)).intValue(), 
					new Double(getLineReference().getY(i)).intValue());
		}
		return ret;
	}*/
	
	public void setColor(Color c) {
		model.color = c;
	}
	
	public void setStroke(Stroke s) {
		stroke = s;
	}
	
	/*
	public int getPointCount() {
		return line.npoints;
	}*/
	
	public Color getColor() {
		return model.color;
	}
	
	public int getId() {
		return model.id;
	}
	
	public BGElementModel getModel() {
		return BGElementController.copy(model);
	}
	
	public int getPointCount() {
		return model.poly.npoints;
	}
	
	public void paint(PPaintContext c) {
		Graphics2D g = c.getGraphics();
		g.setColor(model.color);
		g.setStroke(stroke);
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
		g.drawPolyline(model.poly.xpoints, model.poly.ypoints, model.poly.npoints);
		//g.draw(super.getLineReference());
	}
	
	public boolean equals(BGElementPainter painter) {
		if (painter.model.poly.npoints != model.poly.npoints)
			return false;
		
		for (int i = 0; i < painter.model.poly.npoints; i++) {
			if (painter.model.poly.xpoints[i] != model.poly.xpoints[i] &&
					painter.model.poly.ypoints[i] != model.poly.ypoints[i])
				return false;
		}
		return true;
	}
	
	public void setPoly(Polygon p) {
		model.poly = p;
		setBounds(p.getBounds2D());
	}
	
}
