package ics.uci.edu.Calico.UI.components;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;

import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.util.PPaintContext;

import ics.uci.edu.Calico.UI.CalicoCanvas;
import ics.uci.edu.Calico.UI.components.CalicoGrid.CGCell;
import ics.uci.edu.Calico.models.ObjectHandlerModel;
import ics.uci.edu.Calico.models.actions.PenColorChanged;

public class PenColorChooser extends CalicoComponent {

	Color[] colors;
	int activeColor;
	CalicoCanvas canvas;
	int circleOffset = 10;
	int circleSize = 20;
	int xOffset = 20;
	int yOffset = 5;
	
	//Ellipse2D cir1, cir2, cir3, cir4;
	Ellipse2D[] circles;
	
	public PenColorChooser() {
		this(Color.BLACK);
	}
	
	public PenColorChooser(Color def) {
		this(Color.black, Color.black, Color.blue, Color.red, new Color(0, 150, 50), Color.ORANGE, new Color(92,51,23), new Color(153,50,205));
	}
	
	public PenColorChooser(Color def, Color c0, Color c1, Color c2, Color c3,
							Color c4, Color c5, Color c6) {
		colors = new Color[7];
		colors[0] = c0;
		colors[1] = c1;
		colors[2] = c2;
		colors[3] = c3;
		colors[4] = c4;
		colors[5] = c5;
		colors[6] = c6;
		
		activeColor = 0;
		for (int i = 0; i < colors.length; i++) {
			if (def.equals(colors[i]))
				activeColor = i;
		}
		
		this.addInputEventListener(new PCCListener());
	}
	
	/*
	public PenColorChooser(Color def, Color c0, Color c1, Color c2, Color c3) {
		colors = new Color[4];
		colors[0] = c0;
		colors[1] = c1;
		colors[2] = c2;
		colors[3] = c3;
		
		if (def.equals(c0))
			activeColor = 0;
		else if (def.equals(c1))
			activeColor = 1;
		else if (def.equals(c2))
			activeColor = 2;
		else if (def.equals(c3))
			activeColor = 3;
		else {
			System.err.println("Default color does not match any existing colors, defaulting to first Color");
			activeColor = 0;
		}
		
		this.addInputEventListener(new PCCListener());
		
	}*/
	
	public void setColor(int c) {
		if (c < 0 || c > colors.length-1) {
			System.err.println("PenColorChooser:setColor - color choice " + c + " out of index");
			return;
		}
		activeColor = c;
		canvas.applyAction(new PenColorChanged(colors[c]));
		//System.out.println("New color selected:" + c);
	}
	
	
	
	public void paint(PPaintContext c) {
		Graphics2D g = c.getGraphics();
		
		Color col = g.getColor();

		for (int i = 0; i < circles.length; i++) {
			g.setColor(colors[i]);
			g.fill(circles[i]);
		}
	}
	
	@Override
	public void registerCanvas(CalicoCanvas c) {
		canvas = c;
	}

	@Override
	public boolean updateBounds(int width, int height) {
		circles = new Ellipse2D[7];
		if (setBounds(xOffset, height - circleSize - yOffset, (circleSize+circleOffset)*colors.length, circleSize))  {
			for (int i = 0; i < circles.length; i++) {
				circles[i] = new Ellipse2D.Double(xOffset + (circleSize+circleOffset)*i, height - circleSize - yOffset, circleSize, circleSize);
			}
			
			return true;
		}
		return false;
	}
	
	private class PCCListener extends PBasicInputEventHandler {
		
		public void mousePressed(PInputEvent e) {
			for (int i = 0; i < circles.length; i++) {
				if (circles[i].contains(e.getCanvasPosition()))
					setColor(i);
			}
		}
	}

}
