package ics.uci.edu.Calico.classroom;

import ics.uci.edu.Calico.UI.CalicoCanvas;
import ics.uci.edu.Calico.networking.ClientWorker;

import java.awt.Dimension;
import java.net.Socket;

class CanvasInstance{
	
	private CanvasImage image;
	private ClientWorker clientWorker;
	private CalicoCanvas canvas;
	private boolean isCanvas;
	private boolean alive;
	private Socket socket;
	private String nickname;
	private boolean expanded;
	
	CanvasInstance(ClientWorker cW){
		nickname = cW.getNickname();
		clientWorker = cW;
		//canvas = cW.getCalicoCanvas();
		isCanvas = true;
		image = null;
		alive = true;
	}
	
	public void expanded(){
		expanded = true;
	}
	
	public void unExpand(){
		expanded = false;
	}
	
	public boolean isExpanded(){
		return expanded;
	}
	
	
	public void kill(){
		alive = false;
	}
	
	
	public boolean isAlive(){
		return alive;
	}
	
	public boolean isCanvas(){
		return isCanvas;
	}
	
	public void updateNickname(){
		nickname = clientWorker.getNickname();
	}
	
	public void setImage(){
		//if(image != null)
			//image = new CanvasImage(canvas.getImage());
		//else
			//image = new CanvasImage(new VBCanvas().getImage());
		//isCanvas = false;
		//canvas = null;
		//image.setVisible(true);
		//image.setPreferredSize(new Dimension(110,100));
	}
	
	public void setCanvas(CalicoCanvas vbCanvas){
		canvas = vbCanvas;
		canvas.removeInputEventListener(canvas.getPanEventHandler());
		canvas.getCamera().scaleViewAboutPoint(.2, 0, 0);//.1,0,0
		canvas.repaint();
		expanded = false;
		//this.image = null;
		isCanvas = true;
	}
	
	public Socket getSocket(){
		return socket;
	}
	
	public ClientWorker getClientWorker(){
		return clientWorker;
	}
	
	public CalicoCanvas getCanvas(){
		return canvas;
	}
	
	public CanvasImage getImage(){
		return image;
	}
	
	public String getNickname(){
		return nickname;
	}
	
	public void setNickname(String name){
		nickname = name;
	}
}