package ics.uci.edu.Calico.classroom;

import ics.uci.edu.Calico.models.ObjectHandlerModel;
import ics.uci.edu.Calico.models.actions.CalicoAction;
import ics.uci.edu.Calico.networking.NetworkPacket;
import ics.uci.edu.Calico.networking.SocketClient;

import java.io.IOException;
import java.io.ObjectInputStream;

public class ClassClientInputListener implements Runnable{
	
	private ClassroomSocketClient client;
	private ObjectInputStream in;
	
	
	ClassClientInputListener(ObjectInputStream in, ClassroomSocketClient client){
		this.client = client;
		this.in = in;
	}
	

	public void run(){
		NetworkPacket networkPacket;
		int packetID;
		    while(client.isConnected()){
			      try {
			    	  networkPacket = (NetworkPacket)in.readObject();
			    	  packetID = networkPacket.getPacketID();
			    	  if(packetID == networkPacket.CALICO_ACTION){
			    		  CalicoAction action = networkPacket.getCalicoAction();
			    		  client.performAction(action);
			    	  }
			    	  else if(packetID == networkPacket.PREMADE_CANVAS){
			    		  ObjectHandlerModel premadeCanvas = networkPacket.getPremadeCanvas();
			    		  client.setCanvas(premadeCanvas);
			    		  client.sendCanvas(premadeCanvas);
			    	  }    	 
					} catch (IOException e) {
						finalize();
			      	} catch (ClassNotFoundException e) {
					System.out.println("Class Not Found");
					e.printStackTrace();
					} catch (NullPointerException e){
						//PINGED!!!!!!
					}
		    }
	}

	public void finalize(){
		try {
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


}
