package ics.uci.edu.Calico.classroom;

import ics.uci.edu.Calico.UI.CalicoCanvas;
import ics.uci.edu.Calico.UI.components.Menu;
import ics.uci.edu.Calico.models.ObjectHandlerModel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import java.util.Vector;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;

public class ClassroomMenu extends Menu{
	
	private static final long serialVersionUID = 1L;

	//JMenu file = new JMenu("File");
	//JMenu tools = new JMenu("Tools");   
	
	
	private CalicoCanvas canvasToBeSent;
	private Vector<ClassroomClientWorker> canvasList;
	private Vector<ClassroomClientWorker> activeUserList;
	private ObjectHandlerModel loadedCanvas;
	private ExpandedFrame expandedFrame;
	private ClassroomServerUI server;
	private ClassroomClientUI client;
	
	public ClassroomMenu(){
		
	}
	
	  
	  public void addConnect(ClassroomClientUI client){
		  this.client = client;
		  JMenuItem addConnect = new JMenuItem("Connect");
		  addConnect.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					drawConnectFrame();		
				}
		    });
		    tools.add(addConnect);
	  }
	  
	  private void drawConnectFrame(){
		  client.drawConnectionFrame();
	  }
	  
	  public void addDisconnect(ClassroomClientUI client){
		  this.client = client;
		  JMenuItem addDisconnect = new JMenuItem("Disconnect");
		  addDisconnect.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					addDisconnectFrame();		
				}
		    });
		    tools.add(addDisconnect);
	  }
	  
	  private void addDisconnectFrame(){
		  client.disconnect();
	  }
	
	
	  public ObjectHandlerModel getLoadedCanvas(){
		  return loadedCanvas;
	  }
	  
	  
	  public void addEditor(ClassroomServerUI server){
		  this.server = server;
		  
		  JMenuItem editor = new JMenuItem("Create Canvas to Send");
		    editor.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
						premadeCanvasEditor();			
				}
		    });
		    file.add(editor);
	  }
		  
	  
	  private void premadeCanvasEditor(){
		  this.canvasList = server.getActiveList();
		  new ExpandedFrame(canvasList);
	  }
	  
	  public void addSendCanvasAll(ExpandedFrame eF){
		  expandedFrame = eF;
		  JMenuItem sender = new JMenuItem("Send to All");
		    sender.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
						sendCanvasToAll();			
				}
		    });
		    file.add(sender);
	  }
	  
	  private void sendCanvasToAll(){
		  int counter = 0;
		  canvasToBeSent = expandedFrame.getCanvas();
		  activeUserList = expandedFrame.getActiveClientsList();
			for(ClassroomClientWorker cInstance: activeUserList){
				if(cInstance.isConnected()){
					cInstance.sendCanvas(canvasToBeSent.getModel());
					counter++;
					}
			}
			if(counter==0)
				message("There are currently no active clients.");
			
		}
	  
	  private void message(String message){
		   JFrame errorFrame = new JFrame();
		   JOptionPane.showMessageDialog(errorFrame,
				    message,
				    "Server Error",
				    JOptionPane.INFORMATION_MESSAGE);
		   
	   }
	  
	class MyFilter extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            return filename.endsWith(".vbc");//VBOARD CANVAS
        }
        public String getDescription() {
            return "*.vbc";
        }
    }
	
	
	
}


