package ics.uci.edu.Calico.classroom;


import ics.uci.edu.Calico.networking.ClientWorker;

import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.net.*;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.Timer;

public class ClassroomServer{
	
	private static final long serialVersionUID = 1L;
	private ServerSocket server;
	private Vector<ClassroomClientWorker> canvasList = new Vector<ClassroomClientWorker>();
	private Vector<ClassroomClientWorker> clientWorkerList = new Vector<ClassroomClientWorker>();
	private ClassroomServerUI serverUI;
	
   public ClassroomServer(ClassroomServerUI ui){
	   serverUI = ui;
	   server = null;
	   listenSocket();
   } 
   
   public void listenSocket(){
	   int counter = 0;
	   System.out.println("Starting Server");
	    try{
	    	server = new ServerSocket(6112);//server is a socket made through port 6112
	    } catch (IOException e) {//if port cannot be found/port-failed exit
	      message("Server Cannot Connect\nport 6112 is in use");
	      System.exit(-1);
	    }
		    //READ IN DATA
		    while(true){
		    	ClassroomClientWorker w;
		      try {
		    	  	System.out.println(1);
			    	w = new ClassroomClientWorker(server.accept());
			    	System.out.println(2);
			    	Thread t = new Thread(w);
			    	System.out.println(3);
			    	t.start();
			    	clientWorkerList.add(w);
			    	refreshNickname();
			    	canvasList.add(w);
			    	serverUI.setCanvasList(canvasList);
			    	serverUI.addToGrid();
			    	counter++;
			    	if(counter==1)
			    		setTimer();
			    	refreshNickname();
			    	System.out.println("loop");
				} catch (IOException e) {
				System.out.println("IO connection could not be made");
				e.printStackTrace();
		      	}
		    }
	  }
   
   private void pingAll(){
	   for(ClassroomClientWorker cW : clientWorkerList){
		   if(cW.ping()==false){
			   cW.kill();
			   if(cW.isExpanded())
				   message("Client is Inactive!");
		   }
	   }
   }
   
   
   private void refreshNickname(){
	  /* for(CanvasInstance cI : canvasList){
		   cI.updateNickname();
	   }*/
   }
   
   
   
   private void setTimer(){
	   int delay = 500; //milliseconds(1000ms = 1s)
	   ActionListener taskPerformer = new ActionListener() {
	       public void actionPerformed(ActionEvent evt) {
	    	  // refreshNickname();
	           serverUI.addToGrid();
	           pingAll();
	       }
	   };
	   new Timer(delay, taskPerformer).start();
   }

  protected void finalize(){
//	Clean up 
	     try{
	         server.close();
	    } catch (IOException e) {
	        System.out.println("Could not close.");
	        System.exit(-1);
	    }
	  }
  

   
   private void message(String message){
	   JFrame errorFrame = new JFrame();
	   JOptionPane.showMessageDialog(errorFrame,
			    message,
			    "Server Message",
			    JOptionPane.INFORMATION_MESSAGE);
	   
   }
}
