package ics.uci.edu.Calico.classroom;

import java.awt.Dimension;

import javax.swing.JFrame;

import ics.uci.edu.Calico.UI.MouseInputHandler;
import ics.uci.edu.Calico.UI.CalicoCanvas;
import ics.uci.edu.Calico.models.ObjectHandlerModel;

public class ClientPremadeCanvasEditor extends JFrame{

	
	private static final long serialVersionUID = 1L;
	private ObjectHandlerModel premadeCanvas;
	private CalicoCanvas canvas;
	private ClassroomMenu menu;
	
	ClientPremadeCanvasEditor(ObjectHandlerModel premadeCanvas){
		this.premadeCanvas = premadeCanvas;
		drawFrame();
    	setPreferredSize(new Dimension(700,700));
    	setTitle("Client Premade Canvas Editor");
    	setVisible(true);
    	pack();
	}
	
	//FOR TESTING LOOK AND FEEL
	ClientPremadeCanvasEditor(){
		drawFrame();
    	setPreferredSize(new Dimension(700,700));
    	setVisible(true);
    	pack();
	}
	
	private void drawFrame(){
		canvas = new CalicoCanvas();
		//canvas.setPreferredSize(new Dimension(550,550));
		canvas.setVisible(true);
		canvas.removeInputEventListener(canvas.getZoomEventHandler());
		canvas.removeInputEventListener(canvas.getPanEventHandler());
		canvas.addInputEventListener(new MouseInputHandler(canvas));
		canvas.loadModel(premadeCanvas);
		this.add(canvas);
	}
	
	 public static void main(String[] args){
		 new ClientPremadeCanvasEditor();
	 }
	
}
