package ics.uci.edu.Calico.models;

import java.awt.Color;
import java.awt.Polygon;
import java.io.Serializable;
import java.util.ArrayList;

public class ScrapModel implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//This is the outside polygon that gives this scrap its shape
	public Polygon encasingPoly;
	//public ArrayList<DrawingFigure> encasedFigures;
	public ArrayList<Polygon> encasedFigures;
	public ArrayList<Color> encasedFigureColors;
	
	public int id;
	public boolean transparent;
	
	public static Color defaultBackground = new Color(245, 245, 245);
	public static Color defaultBorder = Color.BLACK;
	public static Color defaultSelectedBorder = Color.BLUE;
	private Color background;
	private Color border;
	private Color selectedBorder;
	
	public ScrapModel(Polygon p, int id) {
		this.id = id;
		encasingPoly = p;
		encasedFigures = new ArrayList<Polygon>();
		encasedFigureColors = new ArrayList<Color>();
		transparent = false;
		
		//Set colors to default values
		background = defaultBackground;
		border = defaultBorder;
		selectedBorder = defaultSelectedBorder;
	}
	
	/*
	public class DrawingFigure implements Serializable {
		public Polygon p;
		public Color c;
		
		public DrawingFigure(Polygon p, Color c) {
			this.p = p;
			this.c = c;
		}
		
		public void setColor(Color thisColor){
			c = thisColor;
		}
	}*/
	
	public boolean equals(ScrapModel s) {
		return (s.id == id);
	}
	
	public boolean equals(int scrapId) {
		return (id == scrapId);
	}
	
	
	public int encasedFiguresSize(){
		return encasedFigures.size();
	}
	
	public Polygon getEncasedFigure(int i){
		return encasedFigures.get(i);
	}
	
	//Alex: Color getting/setting functions:
	//******************************
	
	//Set functions for each color
	public void setBackgroundColor(Color bg){
		background = bg;}
	public void setBorderColor(Color b){
		border = b;}
	public void setSelectedBorderColor(Color sb){
		selectedBorder = sb;}

	//Takes 3 colors: The background color, the border color, and the border color when the scrap is selected
	public void setColors(Color bg, Color b, Color sb){
		background = bg;
		border = b;
		selectedBorder = sb;
	}
	
	public void setColorsToDefault(){
		background = defaultBackground;
		border = defaultBorder;
		selectedBorder = defaultSelectedBorder;
	}
	
	//Get functions for each color
	public Color getBackgroundColor(){
		return background;}
	public Color getBorderColor(){
		return border;}
	public Color getSelectedBorderColor(){
		return selectedBorder;}
	
	//Alex: Check whether this is in the same place as another Scrap
	public boolean compareLocation(ScrapModel other){
		if(encasingPoly.getBounds().getX() != other.encasingPoly.getBounds().getX()){
			return false;}
		if(encasingPoly.getBounds().getY() != other.encasingPoly.getBounds().getY()){
			return false;}
		return true;
	}
}
