/*
 * Creator: Brad Dykzeul
 * Created on Jan 1, 2008
 * Copyright, 2007 University of California
*/
package ics.uci.edu.Calico.networking;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class BuddyList extends JFrame{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Vector<String> buddyList;
	private GridBagConstraints c;
	private int numberOfBuddies;
	private int defaultHeight;
	
	public BuddyList(){
		buddyList = new Vector<String>();
		c = new GridBagConstraints();
		numberOfBuddies = 0;
		defaultHeight = 0;
		drawFrame();
	}
	
	private void drawFrame(){
		setTitle("Buddy List");
		setLayout(new GridBagLayout());
		setPreferredSize(new Dimension(100,defaultHeight));
		setBackground(Color.DARK_GRAY);
		setVisible(true);
		pack();
		repaint();
	}
	
	public void addBuddy(String buddy){
		numberOfBuddies++;
		defaultHeight+= 60;
		setPreferredSize(new Dimension(100,defaultHeight));
		JLabel label = new JLabel(buddy);
		JPanel panel = new JPanel();
		panel.add(label);
		panel.setBackground(Color.RED);
		c.anchor = GridBagConstraints.PAGE_START;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.weightx = 1.0;
		c.weighty = .5;
		c.gridy = numberOfBuddies;
		add(panel,c);
		buddyList.add(buddy);
		repaint();
		pack();
	}
	
	public void removeBuddy(String buddy){
		if(buddyList.remove(buddy))
			numberOfBuddies--;
	}
	
	public Vector<String> getBuddyList(){
		return buddyList;
	}
	

	 public static void main(String[] args){
		 	BuddyList frame = new BuddyList();
	        WindowListener l = new WindowAdapter() {
	                public void windowClosing(WindowEvent e) {
	                        System.exit(0);
	                }
	        };
	        frame.addBuddy("Bob");
	        frame.addBuddy("Brad");
	        frame.addBuddy("Nick");
	        frame.addWindowListener(l);
	        frame.pack();
	        frame.setVisible(true);
	  }
	
	
}
