/*
 * Creator: Brad Dykzeul
 * Created on Mar 9, 2008
 * Copyright, 2007 University of California
*/
package ics.uci.edu.Calico.networking;

import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.TextArea;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import java.util.Scanner;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JPanel;

public class StandAloneServer extends JFrame{
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel grid;
	private TextArea console;
	private JMenu menu; 
	private GridBagConstraints d = new GridBagConstraints();
	private ArrayList<TextArea> boxes = new ArrayList<TextArea>();
	
	
	
	public static void main(String[] vars){
		StandAloneServer server = new StandAloneServer();
		WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                    System.exit(0);
            }
		};
		server.drawFrame();
	    server.addWindowListener(l);
		server.start();
	}
	
	public void start(){
		
		SocketMultiThreadedServer server = new SocketMultiThreadedServer(this);
		server.run();
	}
	
	private void drawFrame(){
		
		
		
		
		GridBagConstraints c = new GridBagConstraints();
		
		
		setTitle("Calico Alpha Server");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//setPreferredSize(new Dimension(600,600));
		setVisible(true);
		
		setLayout(new GridBagLayout());
		
		menu = new JMenu();
		/*c.fill = GridBagConstraints.HORIZONTAL;
		c.weightx = 1.0;
		c.weighty = 0;
		c.gridy = 0;
		c.gridwidth = 4;
		c.anchor = GridBagConstraints.FIRST_LINE_START;
		add(menu,c);*/
		
		grid = new JPanel();
		grid.setLayout(new GridBagLayout());
		c.fill = GridBagConstraints.HORIZONTAL;
		c.anchor = GridBagConstraints.FIRST_LINE_START;
		//c.ipady = 450;
		//c.ipadx = 350;
		c.weightx = 1.0;
		c.weighty = 1.0;
		c.gridy = 1;
		grid.setBackground(Color.BLACK);
		add(grid,c);
		
		console = new TextArea();
		console.setText("Shared Grid Console v. 1.0" + '\n');
		c.fill = GridBagConstraints.BOTH;
		//c.ipadx = 150;
		c.ipady = -50;
		c.weightx = 1.0;
		c.weighty = 1.0;
		c.gridy = 2;
		c.anchor = GridBagConstraints.PAGE_END;
		//console.setBackground(Color.PINK);
		add(console, c);
		
		
		repaint();
		pack();
	}
	
	private int gridX = 0;
	private int gridY = 0;
	
	public void addToFrame(Integer position){

		if(gridX == 5){
			gridY++;
			gridX=0;
		} 
		
		TextArea textBox = new TextArea("",0,0,3);
		textBox.setText(position.toString());
		textBox.setPreferredSize(new Dimension(100,100));
		
		
		
		
		d.weighty = 0.0;
		d.weightx = 0.0;
		d.gridx = gridX;
		d.gridy = gridY;
		d.insets = new Insets(10,10,10,10);//creates the gap between frames
		d.anchor = GridBagConstraints.FIRST_LINE_START;
		grid.add(textBox,d);
		
		boxes.add(textBox);
		
		grid.repaint();
		pack();
		repaint();
		
		gridX++;	
	}
	
	public void addUser(int ID, String user){
		getTextArea(ID).append('\n' + user);
	}
	
	public void markAsUpdated(int ID){
		getTextArea(ID).setBackground(Color.pink);
	}
	
	public void markAsNotUpdated(int ID){
		getTextArea(ID).setBackground(Color.white);
	}
	
	public TextArea getTextArea(int ID){
		TextArea temp = new TextArea();
		for(TextArea text : boxes){
			
			Scanner scanner = new Scanner(text.getText());
			int stringID = scanner.nextInt();
			//System.out.println("active: " + stringID);
			//System.out.println("looking for: " + ID);
			
			if(stringID == ID){
				temp = text;
			}
		}
		return temp;
	}
	
	public void toConsole(String text){
		console.append(text + '\n');
	}
	
	public void removeUser(String name){
		
		Scanner scanner;
		

		for(TextArea text : boxes){
			scanner = new Scanner(text.getText());
			String temp = "";
			//scanner.has
			while(scanner.hasNext()){
				temp = scanner.next();
				if(temp.equals(name))
					text.append('\n' + name + ":DISC");
				
			}
		}
		
		pack();
		repaint();
		
	}
	
	
	
	
	
	

}
